SystemOrganization addCategory: #SwazooSpike!

SwazooResource subclass: #S2JWebApp
	instanceVariableNames: 'localResponseId'
	classVariableNames: 'globalResponseId responseContent'
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
applicationPath

	^ '/app'.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/2/2010 11:27'!
defaultPort

	^ 8887! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId
	^ globalResponseId! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId: anObject
	globalResponseId := anObject! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
increaseResponseId

	self globalResponseId: self globalResponseId + 1.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
inputPath

	^ '/put'.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
isInstalled

	^ self site notNil.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 20:55'!
prepareSite

	| site |
	site := SwazooSite newNamed: self siteName. 
	site
		host: '*'
		ip: '*'
		port: self defaultPort;
		addResource: (self uriPattern: '/').
	^ site.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/2/2010 11:28'!
removeSite

	SwazooServer singleton removeSite: self site.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
resetContent

	self
		globalResponseId: 0;
		responseContent: nil.
	self allInstances do: [ : each  | each localResponseId: 0 ]. ! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:28'!
responseContent
	^responseContent
! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:15'!
responseContent: anObject
	responseContent := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
site

	^ SwazooServer singleton siteNamed: self siteName.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 21:39'!
siteName

	^ 'S2JWebApp'.! !

!S2JWebApp class methodsFor: 'launch' stamp: 'HK 12/1/2010 21:32'!
startWebApp

	self isInstalled ifFalse: [ self prepareSite ].
	self site start.
! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:48'!
updateResponseContentWith: content

	self responseContent: content.
	self increaseResponseId.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:45'!
xmlPath

	^ '/xml'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/2/2010 10:55'!
answerContent: data

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: 'xml';
		entity: data;
		yourself.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/2/2010 13:40'!
answerNothing

	^ HTTPResponse forbidden.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/1/2010 20:59'!
answerTo: aRequest 

	| resource response |
	resource := self identifierOf: aRequest.
	response := self handleRequest: aRequest for: resource.
	^ response.
! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/2/2010 13:39'!
answerXmlData

	self hasNewData
		ifTrue:
			[ self localResponseId: self class globalResponseId.
			^self answerContent: (self wrapUpAsXml: self class responseContent) ]
		ifFalse: [ ^ self answerNothing ].
! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 13:24'!
cssData 

	^ 'body {
		font-family: Verdana;
		margin: 0px;
		padding: 0px;
	}
	
	#container {
		width: 80%;
		margin: 0px auto;
	}
	
	table {
		width: 100%;
	}
	
	td {
		width: 33%;
	}
	
	.red {
		background-color: #D15600;
	}
	
	.yellow {
		background-color: #FFFF88;
	}
	
	.green {
		background-color: #6BBA70;
	}'.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/2/2010 13:50'!
handleInputOf: aRequest

	| content |
	content := self postDataOf: aRequest.
	content ifNotNil: [self class updateResponseContentWith: content].
	^ self answerContent: 'OK'.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/2/2010 13:36'!
handleRequest: aRequest for: aResource

	aResource = self class applicationPath ifTrue: [ ^ self answerContent: self website ].
	aResource = self class xmlPath ifTrue: [ ^ self answerXmlData ].
	aResource = self class inputPath ifTrue: [ ^ self handleInputOf: aRequest ].
	^ self answerNothing.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:08'!
hasNewData

	^ self class responseContent notNil and: [ self class globalResponseId > self localResponseId ].! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'SW 12/1/2010 16:08'!
identifierOf: aRequest

	^ aRequest requestLine requestURI identifier.! !

!S2JWebApp methodsFor: 'instance creation' stamp: 'HK 12/2/2010 11:10'!
initialize

	super initialize.
	self localResponseId: 0.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 13:40'!
javascriptCode

	^ '
	var interval;
	var intervalLength = 3000;
	var request;
	
	function createXmlRequest() {
		return new XMLHttpRequest();
	}
	
	function poll() {
		request = createXmlRequest();
		request.open("GET", "/xml", true);
		request.onreadystatechange = pollRequestHandler;
		request.send(null);
	}
	
	function pollRequestHandler() {
		if (request.readyState == 4) {
			if (request.status == 200) {
				var xml = request.responseXML.getElementsByTagName("data")[0].firstChild.data;
				log(request.status, xml);
			}
			else {
				log(request.status, null);
			}
		}
	}

	function startPolling() {
		interval = setInterval("poll();", intervalLength);
	}

	function stopPolling() {
		clearInterval(interval);
	}
	
	function log(httpStatus, content) {
		if (content == null) {
			prependRow("yellow", httpStatus, "Nothing changed", "");
		}
		else {
			var evaluatedContent;
			try {
  				evaluatedContent = eval(content);
				prependRow("green", httpStatus, content, evaluatedContent);
			}
			catch(error) {
				prependRow("red", httpStatus, content, error);
			}
		}	
	}
		
	function prependRow(cssClass, httpStatus, logText, evalText) {
		var row = document.createElement("tr");
		row.setAttribute("class", cssClass);
		var httpData = document.createElement("td")
		var logData = document.createElement("td")
		var evalData = document.createElement("td")
		var tbody = document.getElementsByTagName("tbody")[0];
		httpData.innerHTML = httpStatus,
		row.appendChild(httpData);
		logData.innerHTML = logText;
		row.appendChild(logData);
		evalData.innerHTML = evalText;
		row.appendChild(evalData);
		tbody.appendChild(row)
	}
	
	function sendData() {
		data = document.getElementById("input").value;
		if (data !!= "") {
			request = createXmlRequest();
			request.open("POST", "/put", true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.send(data);
		}
	}
	
	function clearLog() {
	
	}
	
	function alert(text) {
		return text;
	}'.! !

!S2JWebApp methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
localResponseId
	^ localResponseId! !

!S2JWebApp methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
localResponseId: anObject
	localResponseId := anObject! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 10:50'!
postDataOf: aRequest

	aRequest isPostDataEmpty ifTrue: [ ^ nil ].
	^ aRequest postData keys any.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 10:03'!
renderBody

	^ '<body><div id="container">',
	self renderContent,
	'</div></body></html>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 13:43'!
renderContent

	^ '<h3>Post code</h3>
	<p><textarea id="input"></textarea></p>
	<p>
	<input type="button" value="Poll once" onclick="poll();">
	<input type="button" value="Start polling" onclick="startPolling();">
	<input type="button" value="Stop polling" onclick="stopPolling();">
	<input type="button" value="Clear log" onclick="clearLog();">
	<input type="button" value="Send data" onclick="sendData()">
	</p>
	<h3>Log</h3>
	<table>
	<thead>
	<tr>
	<th>HTTP</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	</div>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
renderHeader

	^ self htmlDocumentType,
	'<html><head><title>',
	self class siteName,
	'</title><script type="text/javascript">',
	self javascriptCode,
	'</script><style type="text/css"><!!--',
	self cssData,
	'--></style></head>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 21:37'!
website

	^ self renderHeader,
	self renderBody.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 10:55'!
wrapUpAsXml: content

	^ self xmlDocumentType, '<data>', content, '</data>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 00:16'!
xmlDocumentType

	^ '<?xml version="1.0"?>'.
! !
